SystemOrganization addCategory: #'Magritte-XMLBinding'!
SystemOrganization addCategory: #'Magritte-XMLBinding-Test'!

!MAElementDescription class methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
descriptionXmlAttributeName
	^(MAStringDescription selector: #xmlAttributeName label: 'XML Attribute Name' priority: 1100)! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
xmlAttributeName
	^self
		propertyAt: #xmlAttributeName
		ifAbsent: [ self accessor selector asString ]! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
xmlAttributeName: aString
	self propertyAt: #xmlAttributeName put: aString! !

Object subclass: #MXObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXObject class methodsFor: 'accessing-description' stamp: 'NorbertHartl 2/15/2010 11:27'!
descriptionContainer
	^super descriptionContainer
		xmlElementName: self xmlElementName;
		yourself! !

!MXObject class methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 11:27'!
forElementNamed: aString
	self withAllConcreteClassesDo: [ :each |
		(each xmlElementName = aString)
			ifTrue: [ ^each new ] ].
	self error: 'unknown element name: ', aString! !

!MXObject class methodsFor: 'instance creation' stamp: 'NorbertHartl 2/15/2010 11:27'!
fromXml: aString
	^self description fromXml: aString! !

!MXObject class methodsFor: 'testing' stamp: 'NorbertHartl 2/15/2010 11:27'!
isAbstract
	^ true! !

!MXObject class methodsFor: 'reflection' stamp: 'NorbertHartl 2/15/2010 11:27'!
withAllConcreteClasses
	^Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!MXObject class methodsFor: 'reflection' stamp: 'NorbertHartl 2/15/2010 11:27'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!MXObject class methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 11:27'!
xmlElementName
	self subclassResponsibility ! !

!MXObject methodsFor: 'printing' stamp: 'NorbertHartl 2/16/2010 00:15'!
printXMLOn: aStream
	self toXml printXMLOn: (XMLWriter on: aStream)! !

!MXObject methodsFor: 'converting' stamp: 'NorbertHartl 2/16/2010 00:15'!
toXml
	^ self description xmlWriter 
		write: self 
		description: self description! !

MXObject subclass: #MXTestObject
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXTestObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:18'!
descriptionLabel
	^MAStringDescription new
		accessor: #label;
		label: 'Label';
		priority: 100;
		xmlWriter: MXXmlAttributeWriter! !

!MXTestObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:13'!
descriptionName
	^MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 100;
		xmlWriter: MXXmlAttributeWriter! !

!MXTestObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 16:13'!
descriptionSub
	^(MAToOneRelationDescription new 
		accessor: #testsub;
		label: 'TestSub';
		priority: 50) 
		reference: MXTestSubObject description;
		yourself! !

!MXTestObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 12:29'!
isAbstract
	^ false! !

!MXTestObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 12:30'!
xmlElementName
	^ 'testobject'! !

!MXTestObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 12:50'!
xmlWriter
	self halt! !

!MXTestObject methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:18'!
label
	^ label! !

!MXTestObject methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:18'!
label: aString
	label := aString! !

!MXTestObject methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 12:29'!
name
	^ name! !

!MXTestObject methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 12:29'!
name: aString
	name := aString! !

!MXTestObject methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:24'!
testsub
	^ testsub! !

!MXTestObject methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:23'!
testsub: aTestSub
	testsub := aTestSub! !

MXObject subclass: #MXTestSubObject
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXTestSubObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:40'!
descriptionTitle
	^MAStringDescription new
		accessor: #title;
		label: 'Title';
		priority: 100;
		xmlWriter: MXXmlAttributeWriter! !

!MXTestSubObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:42'!
xmlElementName
	^ 'sub'! !

!MXTestSubObject methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:40'!
title
	^ title! !

!MXTestSubObject methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 15:40'!
title: aString
	title := aString! !

MAVisitor subclass: #MXXmlReader
	instanceVariableNames: 'node object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXXmlReader subclass: #MXXmlAttributeReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlAttributeReader methodsFor: 'private' stamp: 'pmm 12/6/2006 12:50'!
childOf: aNode description: aDescription
	^aNode! !

!MXXmlAttributeReader methodsFor: 'private' stamp: 'pmm 12/5/2006 23:37'!
contentsFor: aDescription
	^self node attributeAt: aDescription xmlAttributeName! !

!MXXmlAttributeReader methodsFor: 'private' stamp: 'pmm 12/7/2006 18:23'!
epoch
	^TimeStamp
		year: 1970 month: 1 day: 1
		hour: 0 minute: 0 second: 0
		offset: (Duration seconds: 0)! !

!MXXmlAttributeReader methodsFor: 'visiting-description' stamp: 'pmm 12/5/2006 23:37'!
visitElementDescription: aDescription
	"This implementation can be very dangerous and might lead to a potential security hole, since the default implementation of #readFrom: in Object evaluates the expression to find its value. Most subclasses like Number, Date, Time, ... override this implementation, but some others (like Boolean) do not."

	| contents |
	contents := self contentsFor: aDescription.
	self object: (contents isNil ifFalse: [ aDescription kind readFrom: contents readStream ])! !

!MXXmlAttributeReader methodsFor: 'visiting-description' stamp: 'pmm 12/5/2006 23:37'!
visitStringDescription: aDescription
	self object: (self contentsFor: aDescription)! !

!MXXmlAttributeReader methodsFor: 'visiting-description' stamp: 'pmm 12/6/2006 17:07'!
visitTimeStampDescription: aDescription
	| contents |
	contents := self contentsFor: aDescription.
	self object: (contents isNil ifFalse: [
		| offset seconds |
		seconds := Integer readFrom: contents readStream.
		offset := Duration seconds: seconds.
		self epoch + offset ])! !

MXXmlAttributeReader subclass: #MXXmlElementAttributeReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlElementAttributeReader methodsFor: 'private' stamp: 'pmm 12/6/2006 17:15'!
childOf: aNode description: aDescription
	^aNode elementAt: aDescription xmlElementName! !

MXXmlReader subclass: #MXXmlElementReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlElementReader methodsFor: 'private' stamp: 'pmm 12/6/2006 12:51'!
childOf: aNode description: aDescription
	^aNode elementAt: aDescription xmlElementName! !

!MXXmlElementReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 22:58'!
contents
	^self node contentString! !

!MXXmlElementReader methodsFor: 'private' stamp: 'pmm 12/18/2006 17:07'!
stream
	^self contents readStream! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 3/17/2007 15:33'!
visitComposed: aDescription children: aCollection
	self object: (ASObject forElementNamed: self node name).
	aCollection do: [ :each |
		self object
			write: (each readXml: self node)
			using: each ]! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 12/6/2006 00:33'!
visitContainer: aDescription
	self visitComposed: aDescription children: aDescription children! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 12/5/2006 20:59'!
visitElementDescription: aDescription
	"This implementation can be very dangerous and might lead to a potential security hole, since the default implementation of #readFrom: in Object evaluates the expression to find its value. Most subclasses like Number, Date, Time, ... override this implementation, but some others (like Boolean) do not."

	self object: (aDescription kind readFrom: self stream)! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 12/5/2006 18:53'!
visitStringDescription: aDescription
	self object: self contents! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 3/17/2007 15:58'!
visitToManyRelationDescription: aDescription
	self object: (Array streamContents: [ :stream |
		self node elementsDo: [ :each |
			(each name = aDescription xmlElementName)
				ifTrue:  [ stream nextPut: (aDescription reference readXml: each) ] ] ])! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 3/17/2007 15:10'!
visitToOneRelationDescription: aDescription
	self visitComposed: aDescription children: aDescription reference! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 3/17/2007 12:32'!
visitUrlDescription: aDescription
	self object: self contents unescapePercents! !

MXXmlElementReader subclass: #MXXmlInlineElementReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlInlineElementReader methodsFor: 'private' stamp: 'pmm 12/6/2006 12:49'!
childOf: aNode description: aDescription
	^aNode! !

!MXXmlReader class methodsFor: 'instance creation' stamp: 'pmm 12/6/2006 12:47'!
read: aNode description: aDescription
	^ self new read: aNode description: aDescription! !

!MXXmlReader methodsFor: 'private' stamp: 'pmm 12/6/2006 12:48'!
childOf: aNode description: aDescription
	self subclassResponsibility! !

!MXXmlReader methodsFor: 'private' stamp: 'pmm 12/5/2006 22:57'!
error: aString
	MAReadError signal: aString! !

!MXXmlReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 22:57'!
node
	^node! !

!MXXmlReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 23:19'!
node: anObject
	node := anObject! !

!MXXmlReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 23:19'!
object
	^object! !

!MXXmlReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 23:19'!
object: anObject
	object := anObject! !

!MXXmlReader methodsFor: 'visiting' stamp: 'pmm 12/6/2006 13:01'!
read: aNode description: aDescription
	| child |
	child := self childOf: aNode description: aDescription.
	^child isNil ifFalse: [
		self
			node: child;
			visit: aDescription.
		self object ]! !

MAVisitor subclass: #MXXmlWriter
	instanceVariableNames: 'node object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXXmlWriter subclass: #MXXmlAttributeWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlAttributeWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/15/2010 15:17'!
visitStringDescription: aDescription
	self node attributes 
		at: aDescription xmlAttributeName 
		put: (self object readUsing: aDescription)! !

MXXmlAttributeWriter subclass: #MXXmlElementAttributeWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXXmlWriter subclass: #MXXmlElementWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlElementWriter class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/15/2010 13:55'!
write: anObject description: aDescription
	^ self new write: anObject description: aDescription! !

!MXXmlElementWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/15/2010 17:01'!
visitContainer: aDescription
	node := XMLElement new name: aDescription xmlElementName.
	
	aDescription children do: [:each|
		each xmlWriter new 
			object: self object;
			node: self node;
			visit: each
	]! !

!MXXmlElementWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/15/2010 17:09'!
visitFileDescription: aDescription! !

!MXXmlElementWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/15/2010 17:55'!
visitStringDescription: aDescription
	| element |
	element := XMLElement new
		name: aDescription xmlElementName.
	element addContent: (XMLStringNode string: (self object readUsing: aDescription)).
	self node addElement: element! !

!MXXmlElementWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/15/2010 16:43'!
visitToOneRelationDescription: aDescription
	self node addElement: (aDescription xmlWriter 
			write: (self object readUsing: aDescription) 
			description: aDescription reference)! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 15:01'!
node
	^ node! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 15:01'!
node: aNode
	node := aNode! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 15:01'!
object
	^ object! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 15:01'!
object: anObject
	object := anObject! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/16/2010 00:25'!
visitElementDescription: aDescription
	"aDescription xmlWriter write: self node description: aDescription"! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/15/2010 15:00'!
write: anObject description: aDescription
	self 
		object: anObject;
		visit: aDescription.
	^ self node		! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/16/2010 00:03'!
defaultXmlReader
	^ MXXmlElementReader ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 17:38'!
defaultXmlWriter
	^MXXmlElementWriter ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 18:42'!
descriptionXmlElementName
	^(MAStringDescription selector: #xmlElementName label: 'XML Element Name' priority: 1000)! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 23:43'!
descriptionXmlReader
	^ (MASingleOptionDescription selector: #xmlReader label: 'XML Reader' priority: 1300 default: self defaultXmlReader)
		reference: MAClassDescription new;
		options: (Array
			with: MXXmlElementReader
			with: MXXmlAttributeReader
			with: MXXmlInlineElementReader
			with: MXXmlElementAttributeReader);
		yourself ! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 22:26'!
fromXml: aString
	"Answer an object being parsed from <code>aString</code>."

	^ self fromXml: aString reader: self xmlReader! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 13:04'!
fromXml: aString reader: aParser
	"Answer an object being parsed from <code>aNode</code> using <code>aParser</code>."

	^ aParser
		read: (XMLDOMParser parseDocumentFrom: aString readStream)
		description: self! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 13:15'!
readXml: aNode
	"Answer an object being parsed from <code>aString</code>."

	^ self xmlReader read: aNode description: self! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:17'!
xmlElementName
	^self
		propertyAt: #xmlElementName
		ifAbsent: [ self accessor selector asString ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:16'!
xmlElementName: aString
	self propertyAt: #xmlElementName put: aString! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:16'!
xmlReader
	"Answer a Visitor that can be used to parse the model described by the receiver from a DOM node."

	^ self propertyAt: #xmlReader ifAbsent: [ self class defaultXmlReader ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:16'!
xmlReader: aClass
	self propertyAt: #xmlReader put: aClass! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 12:49'!
xmlWriter
	

	^ self propertyAt: #xmlWriter ifAbsent: [ self class defaultXmlWriter ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 12:50'!
xmlWriter: aClass
	self propertyAt: #xmlWriter put: aClass! !

!MAToManyRelationDescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/16/2010 00:04'!
defaultXmlReader
	^ MXXmlInlineElementReader! !

!MARelationDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 3/17/2007 15:41'!
xmlElementName
	^self
		propertyAt: #xmlElementName
		ifAbsent: [ self reference xmlElementName ]! !
